﻿using System;
using System.Windows;
using System.Windows.Interop;
using System.Timers;

namespace WpfApplication1
{

    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private const int WM_DEVICECHANGE = 0x219;
        System.Timers.Timer aTimer = null;

        public MainWindow()
        {
            InitializeComponent();
            aTimer = new System.Timers.Timer(1000);
            aTimer.Interval = 500;
            aTimer.Enabled = false;
            aTimer.Elapsed += new ElapsedEventHandler(OnTimedEvent);
        }


        private delegate void DeviceChangedMaybe();

        private void OnTimedEvent(object source, ElapsedEventArgs e)
        {
            aTimer.Enabled = false;
            DeviceChangedMaybe M = delegate
            {
                cbConnected.IsChecked = KemoUsb.Connect();            
            };
            Dispatcher.BeginInvoke(M,null);
        }

        private void checkBox1_Click(object sender, RoutedEventArgs e)
        {
            byte b = 0;
            if (checkBox1.IsChecked == true) b |= 1;
            if (checkBox2.IsChecked == true) b |= 2;
            if (checkBox3.IsChecked == true) b |= 4;
            if (checkBox4.IsChecked == true) b |= 8;
            if (checkBox5.IsChecked == true) b |= 16;
            if (checkBox6.IsChecked == true) b |= 32;
            if (checkBox7.IsChecked == true) b |= 64;
            if (checkBox8.IsChecked == true) b |= 128;
            KemoUsb.SetState(b);
        }

        private void Grid_Loaded(object sender, RoutedEventArgs e)
        {
            cbConnected.IsChecked = KemoUsb.Connect();
        }

        protected override void OnSourceInitialized(EventArgs e)
        {
            base.OnSourceInitialized(e);
            HwndSource source = PresentationSource.FromVisual(this) as HwndSource;
            source.AddHook(WndProc);
        }

        private IntPtr WndProc(IntPtr hwnd, int msg, IntPtr wParam, IntPtr lParam, ref bool handled)
        {

            if (msg == WM_DEVICECHANGE)
            {
                aTimer.Enabled = false;
                aTimer.Enabled = true;
            }
            handled = false;
            return IntPtr.Zero;
        }

        private void cbConnected_Click(object sender, RoutedEventArgs e)
        {
            if (cbConnected.IsChecked == true)
                cbConnected.IsChecked = KemoUsb.Connect();
            else
                KemoUsb.Disconnect();
        }

    }
}
