unit kuExample;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, kemo_usb, ExtCtrls;

type
  TkuMain = class(TForm)
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    CheckBox8: TCheckBox;
    cbConnected: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure CheckBoxClick(Sender: TObject);
    procedure cbConnectedClick(Sender: TObject);
  private
    kemoUSB: TKemoUSB;
    procedure wmDeviceChange(var Message: TMessage); message WM_DEVICECHANGE;

  end;

var
  kuMain: TkuMain;

implementation

{$R *.dfm}

procedure TkuMain.wmDeviceChange(var Message: TMessage);
begin
  if kemoUSB.Connected then begin
    cbConnected.Checked := true;
  end else begin
    cbConnected.Checked := kemoUSB.Connect;
  end;
end;


procedure TkuMain.FormCreate(Sender: TObject);
begin
  kemoUSB:=TKemoUSB.Create;
  cbConnected.Checked := kemoUSB.Connect;
end;

procedure TkuMain.FormDestroy(Sender: TObject);
begin
  kemoUSB.Free;
end;

procedure TkuMain.CheckBoxClick(Sender: TObject);
var b: byte;
begin
  b:=0;
  if CheckBox1.Checked then b := b or $01;
  if CheckBox2.Checked then b := b or $02;
  if CheckBox3.Checked then b := b or $04;
  if CheckBox4.Checked then b := b or $08;
  if CheckBox5.Checked then b := b or $10;
  if CheckBox6.Checked then b := b or $20;
  if CheckBox7.Checked then b := b or $40;
  if CheckBox8.Checked then b := b or $80;

  kemoUSB.SetState(b);
end;

procedure TkuMain.cbConnectedClick(Sender: TObject);
begin
  if cbConnected.Checked then begin
    cbConnected.Checked := kemoUSB.Connect;
  end else begin
    kemoUSB.Disconnect;
  end;
end;

end.
