#pragma once
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string>
#include <sstream>
#include <iostream>
#include <guiddef.h>
extern "C" {
#include <hidsdi.h> 
}
#include <setupapi.h>
#include <stdexcept>


class KemoUSB
{
	HANDLE hUSB, hWriteFileEvent;
	bool usbwHandleInUse;
	HIDP_CAPS UsbDeviceCaps;
	bool WriteRaw(unsigned char cmd, unsigned char var1, unsigned char var2, unsigned char var3=0xff, unsigned char var4=0xff, unsigned char var5=0xff);
public:
	bool Connected(void);
	bool SetState(unsigned char state);
	bool Connect(void);
	void Disconnect(void);
	KemoUSB(void);
	~KemoUSB(void);
};


void DisplayLastError (char *S);
BOOL KemoUsb_FindDevice(int VendorID, int Product, SP_INTERFACE_DEVICE_DETAIL_DATA *PdetailData, PHIDP_CAPS DeviceCaps);


//stuff needed to communicate with the firmware
#define kVendorID 0x1781
#define kProductID 0x08C0

//;command_type constants (from host to device)
#define CMD_SET_PORTS			00   //; 2 params: data port 0 and 1
#define CMD_SET_PULLUPS			01   //; 2 params: pullup register port 0 and 1
#define CMD_SET_REGISTER		02   //; 2 params: register adr and value
#define CMD_SET_MEMORY          03   //; 2 params: memory pointer and value
#define CMD_SET_REPORT_TYPE     04   //; 2 params: report type and pointer
#define CMD_ENABLE_INTERRUPT    05   //; 1 param: mask of interrupt (0x02 for microtimer)
#define CMD_DISABLE_INTERRUPT   06   //; 1 param: mask of interrupt (0x02 for microtimer)

#define CMD_CLEAR_COMMANDLIST   0x07   //; no params
#define CMD_CLEAR_MOTOR1        0x17   //no params
#define CMD_CLEAR_MOTOR2        0x27   //no params
#define CMD_CLEAR_MOTOR3        0x37   //no params
#define CMD_CLEAR_MOTOR4        0x47   //no params

#define CMD_DO_NOTHING          0x08   //; for connection test
#define CMD_ADD_CMD1            0x10   //; 3 params: (tick_L8)(tick_H6,D,S)[repeat cnt]
#define CMD_ADD_CMD2            0x20   //; M2
#define CMD_ADD_CMD3            0x30   //; M3
#define CMD_ADD_CMD4            0x40   //; M4

#define CMD_START_RESET         0x09   //; motormask,
#define CMD_SET_STATE           0x0A   //; set state for port1 with mask

//;report_type constants  (device to host)
#define REPORT_NONE              0
#define OBSOLETE_LASTCMDTICK     01   //; no params
#define REPORT_PORTSTUFF         02   //; no params
#define REPORT_VARIABLES         03   //; param pointer into memory
#define REPORT_CURRENTTICK       04   //; no params
#define REPORT_MOTOR_STATUS      05   // out: port0,port1,m1.nextfree,m2.nextfree,m3.nextfree,m4.nextfree

#define CMDLISTSIZE              12   // 14-2 byte for each motor

//cy7c63101 io ports
#define PORT0_Data              0x00   // ; GPIO data port 0
#define PORT1_Data              0x01   // ; GPIO data port 1
#define PORT0_Interrupt         0x04   // ; Interrupt enable for port 0
#define PORT1_Interrupt         0x05   // ; Interrupt enable for port 1
#define PORT0_Pullup            0x08   // ; Pullup resistor control for port 0
#define PORT1_Pullup            0x09   // ; Pullup resistor control for port 1

//device variable address
#define MotorResetFlags         0x12



// USB stuff from windows
#define DBT_DEVICEARRIVAL      0x8000
//#define DIGCF_PRESENT          0x02
//#define DIGCF_DEVICEINTERFACE  0x10


